import uppercamelcase from 'uppercamelcase';
import Vue from 'vue';
import VueClickoutside from 'vue-clickoutside';
Vue.use(VueClickoutside);
Vue.directive('v-clickoutside', VueClickoutside);

const requireAll = requireContext => {
  return requireContext.keys().map(requireContext);
};
const modules = requireAll(require.context(
  'packages',
  true,
  /^((?!node_modules|lib|src).)*[^_]index\.js$/));

const components = {};

modules.forEach(item => {
  const name = uppercamelcase(item.name.replace(/^el-|El/, ''));
  components[name] = item;
});

module.exports = Object.assign({}, {
  install(Vue) {
    Object.keys(components).forEach(key => {
      const item = components[key];
      Vue.component(item.name, item);
    });
  }
}, components);
